<?php
/**
* GruppenDateien
* @author Dennis Reil <Dennis.Reil@offis.de>
* @author Markus Schmees <Markus.Schmees@informatik.uni-oldenburg.de>
* @version $Revision:$
* $Id:$
*/

require_once ("lib/language.inc.php");
require_once ("config/config.inc.php");
require_once ("lib/datei.inc.php");
require_once ("lib/visual.inc.php");
require_once ("lib/functions.php");
		
class GroupFilePlugin extends AbstractStudIPStandardPlugin 
{
	/**
	 *
	 *
	 * 
	 */
	function GroupFilePlugin()
	{
		AbstractStudIPStandardPlugin::AbstractStudIPStandardPlugin();
		$nav = new PluginNavigation();
		$nav->setDisplayname(_("Dateien von Gruppen"));
		$nav->setIcon("img/groupfile.gif");
		$user = $this->getUser();
		$perm = $user->getPermission();		
		$this->setNavigation($nav);		
			
		$this->setPluginiconname("img/groupfile.gif");
		$this->overview = true;
	} 
	
	function hasChanged($lastlogin){
		
		return false;
	}
	
	
	/**
	 *
	 *
	 *
	 */
	function getPluginname()
	{
  		return _("Gruppen-Dateiverwaltung");
  	}  	 	
	
  	function upload(){
  		$db=new DB_Seminar;
  		if($_POST["gruppe"]=="0") {
			// Keine Gruppe vorhanden!
			$msg = "Sie sind keiner Gruppe zugeordnet - ein Datei-Upload daher nicht m&ouml;glich!";
		} else {
				
			//Dokument_id erzeugen
			$dokument_id=md5(uniqid(rand()));
			
			if (!file_exists($GLOBALS["UPLOAD_PATH"]."/group")){
				mkdir($GLOBALS["UPLOAD_PATH"]."/group");
			}
			//Erzeugen des neuen Speicherpfads
			$newfile = $GLOBALS["UPLOAD_PATH"]."/group/$dokument_id";
			
			//Kopieren und Fehlermeldung
			$msg = "Datei&uuml;bertragung gescheitert!";
			if (@copy($GLOBALS["the_file"],$newfile)) {
			  // Kopieren hat geklappt
			
			  // DB-Eintrag vornehmen
			  $date = time();				//Systemzeit
			  $user = $GLOBALS["user"];
			  $user_id = $user->id;			// user_id erfragen...
			  $range_id = "0"; 		
			  $description = "";
			  $name = "";		
			
			  $sql = sprintf("INSERT INTO group_docs SET dokument_id='%s', description='%s', mkdate='%s', chdate='%s', range_id='%s', statusgruppe_id='%s', "
			               ."filename='%s', name='%s', user_id='%s', seminar_id='%s', filesize='%s', autor_host='%s'",
			               $dokument_id, $description, $date, $date, $range_id, $_POST["gruppe"], $GLOBALS["the_file_name"], $name, 
			               $user_id, $_POST["upload_seminar_id"], $GLOBALS["the_file_size"], getenv("REMOTE_ADDR"));
						
			  $db->query($sql);
			  if ($db->affected_rows()) {
			    $msg = "Die Datei \"". $GLOBALS["the_file_name"] ."\" wurde erfolgreich auf den Server &uuml;bertragen!";  	
			  } // Ende von if  
			
			} // Ende von if							
		} // Ende von if-else		
		$this->show();
  	}
  	
  	function download(){
  		$UPLOAD_PATH = $GLOBALS['UPLOAD_PATH'];
  		$file_id = $GLOBALS['file_id'];
  		$file_name = $GLOBALS['file_name'];
  		$perm = $GLOBALS["perm"];
  		$user = $GLOBALS["user"];
		
		$db=new DB_Seminar;
		$db2=new DB_Seminar;
		
		$path_file=$UPLOAD_PATH."/group/".$file_id;
		
		
		//Ersetzung von beim Speichern gefaehrlichen Zeichen. Ich weiss, es geht mit ereg_replace besser, hab ich aber grad keine Zeit, mir die Codes reinzuziehen :)
		$file_name=str_replace(":", "", rawurldecode($file_name));
		$file_name=str_replace(chr(92), "", rawurldecode($file_name));
		$file_name=str_replace("/", "-", rawurldecode($file_name));
		$file_name=str_replace("\"", "-", rawurldecode($file_name));
		$file_name=str_replace("'", "", rawurldecode($file_name));
		$file_name=str_replace(">", "", rawurldecode($file_name));
		$file_name=str_replace("<", "", rawurldecode($file_name));
		$file_name=str_replace("*", "", rawurldecode($file_name));
		$file_name=str_replace("|", "", rawurldecode($file_name));
		$file_name=str_replace("?", "", rawurldecode($file_name));
		
		$content_type="application/octet-stream";
		$content_disposition="attachment";		
		
		//override disposition, if available
		if ($disposition)
			$content_disposition=$disposition;
		
		//determine the type of the object we want to download a file from (only in type=0 mode!)
		$db->query("SELECT * FROM group_docs WHERE dokument_id = '".$file_id."' ");
		$db->next_record();
		
		// Pr�fen, ob Nutzer zum Kurs geh�rt
		$zugriff = true;
		
		if ($perm->have_studip_perm("user", $db->f("seminar_id"))) {
		  // Nutzer ist Teilnehmer
		  
		  if(!$perm->have_studip_perm("tutor", $db->f("seminar_id"))) {
		    // Gruppenzugeh�rigkeit �berpr�fen
		    $db2->query("SELECT * FROM statusgruppe_user WHERE statusgruppe_id='".$db->f("statusgruppe_id")."' AND user_id='".$user->id."'");
		    
		    if($db2->num_rows()==0) {
		    	// KEINE Gruppenzugeh�rigkeit
		    	$zugriff=false;
		    	
		    } // Ende von if  	
		  } // Ende von if
		  	
		} else {
		  // Nutzer ist kein Teilnehmer
		  $zugriff = false;
		
		} // Ende von if-else
		
			
		//Nachricht bei verbotenem Download
		if (!$zugriff) {
			// Start of Output
			StudIPTemplateEngine::showErrorMessage(_("Sie haben keine Zugriffsberechtigung f&uuml;r diesen Download!"));			
			return;
		}
		
		//Datei verschicken
		$filesize = filesize($path_file);
		ob_clean();
		header("Expires: Mon, 12 Dec 2001 08:00:00 GMT");
		header("Last-Modified: " . gmdate ("D, d M Y H:i:s") . " GMT");
		header("Cache-Control: no-store, no-cache, must-revalidate");
		header("Cache-Control: post-check=0, pre-check=0", false);
		if ($_SERVER['HTTPS'] == "on") {
			header("Pragma: public");
		} else {
			header("Pragma: no-cache");
		} // Ende von if-else
		header("Cache-Control: private");
		header("Expires: 0");
		
		header("Content-Type: $content_type; name=\"".rawurldecode($file_name)."\"");
		if ($filesize != FALSE) {
			header("Content-Length: $filesize");
		} // Ende von if
		header("Content-disposition: $content_disposition; filename=\"".rawurldecode($file_name)."\"");
		header("Content-Transfer-Encoding: Binary");
		readfile($path_file);			
		// Anzahl Downloads erh�hen
		$db->query ("UPDATE group_docs SET downloads = downloads + 1 WHERE dokument_id = '$file_id'");
		die();
  	}
  	
  	function delete(){
  	  // Datei soll gel�scht werden
  	  $perm = $GLOBALS["perm"];
  	  $user = $GLOBALS["user"];
  	  $file_id = $GLOBALS["file_id"];  	  
  	  $db=new DB_Seminar;
	  // Rechte pr�fen		  
	  
	  if($perm->have_studip_perm("tutor", $GLOBALS["SessSemName"][1])) {
	    // Nutzer ist Tutor des aktuellen Kurses, Pr�fen ob Datei zum Kurs geh�rt
	    
	    $db->query("SELECT * FROM group_docs WHERE dokument_id='".$file_id."' AND seminar_id='".$GLOBALS["SessSemName"][1]."'");
	    if($db->num_rows()>0) {
	      // L�schen
	      $db->query("DELETE FROM group_docs WHERE dokument_id='".$file_id."'");
	      unlink($GLOBALS["UPLOAD_PATH"]."/group/".$file_id);
	    } // Ende von if
	
	  	
	  } elseif ($perm->have_studip_perm("user", $GLOBALS["SessSemName"][1])) {
	    // Nutzer ist nur Nutzer, pr�fen ob auch Hochlader
	    
	    $db->query("SELECT * FROM group_docs WHERE dokument_id='".$file_id."' AND user_id='".$user->id."'");
	    if($db->num_rows()>0) {
	      $db->query("DELETE FROM group_docs WHERE dokument_id='".$file_id."'");
	      unlink($GLOBALS["UPLOAD_PATH"]."/group/".$file_id);
	    } // Ende von if
	 	
	  } // Ende von if-elseif
	  $this->show();
  	}
  	
	/**
	 *
	 *
	 *
	 */
	function show($subnavi="")
	{
		// get perms
		$perm = $GLOBALS["perm"];				
		$user = $GLOBALS["user"];
		
		// Gruppen abfragen
		$db=new DB_Seminar;
		$db2=new DB_Seminar;
				
		if ($perm->have_studip_perm("tutor", $GLOBALS["SessSemName"][1])) {
		  // Nutzer ist Tutor -> Alle Gruppen+Dateien anzeigen (Herunterladebereich)
		  
		  $db->query("SELECT * FROM statusgruppen WHERE range_id='".$GLOBALS["SessSemName"][1]."' ORDER BY position ASC");
		  
		} elseif ($perm->have_studip_perm("user", $GLOBALS["SessSemName"][1])) {
		  // Nutzer ist User, also nur eigene Gruppenbereiche anzeigen
		
		  $db->query("SELECT * FROM statusgruppen,statusgruppe_user WHERE statusgruppen.statusgruppe_id=statusgruppe_user.statusgruppe_id AND user_id='". $user->id ."' AND range_id='".$GLOBALS["SessSemName"][1]."' ORDER BY name ASC");	
		} // Ende von if-else
		
		?>
		  <tr>
		  	<td class="blank">
		  	<table width="100%">
		<?
		
		// Gruppen sind abgefragt
		if ($db->num_rows()==0) {
		  // Kein Ergebnis herausgekommen, keine Gruppe zuzuordnen
		  echo "<tr><td class=\"blank\">Sie sind keiner Gruppe zugeordnet.</td></tr>";
		  
		} else {
		  // Es gibt Gruppen...
		  ?>
		  <tr>
		  	<td>
			  <table border=0 cellpadding=0 cellspacing=0 width="100%">
		  <?php	  
		  while ($db->next_record()) {
		  	
		  	// Dateien der Gruppe ermitteln
		    $db2->query("SELECT ".$GLOBALS["_fullname_sql"]['full']." AS fullname, group_docs.mkdate,group_docs.dokument_id,group_docs.filename,group_docs.filesize,auth_user_md5.username,group_docs.user_id,group_docs.downloads FROM group_docs LEFT JOIN auth_user_md5 USING (user_id) LEFT JOIN user_info USING (user_id) WHERE group_docs.statusgruppe_id='". $db->f("statusgruppe_id") ."' AND group_docs.seminar_id='". $GLOBALS["SessSemName"][1] ."' ORDER BY group_docs.mkdate DESC");	
		    
		?>
			  <tr>
			  	<td class="blank" valign="top" heigth=21 nowrap><img src='<?=$GLOBALS['ASSETS_URL'] ?>/images/forumleer.gif'><img src='<?=$GLOBALS['ASSETS_URL'] ?>/images/forumleer.gif'></td>			  	
			  	
			  	<td class="printhead" nowrap width="1%" valign="middle"><img src="<?=$GLOBALS['ASSETS_URL']?>/images/nutzer.gif"></td>
			  	<td class="printhead" colspan="2" align="left" width="20%" nowrap valign="bottom">&nbsp;Gruppe <a href="sms_send.php?sms_source_page=<?= rawurlencode("plugins.php?id=GroupFilePlugin&cmd=show&")?>&group_id=<? echo $db->f("statusgruppe_id") ?>"><? echo $db->f("name") ?>&nbsp;<img src="<?=$GLOBALS['ASSETS_URL'] ?>/images/cont_nachricht.gif" border="0"/></a>&nbsp;&nbsp;(<?php 
			  		echo($db2->num_rows()); 
			  		if ($db2->num_rows()==1) 
			  			echo(" Dokument");
			  		else
			  			echo (" Dokumente");
			  		?>)</td>
			  	<td align="right" nowrap class="printhead" width="99%" valign='bottom'>&nbsp;<?php
			  		if ($db2->num_rows()==0){
			  		}
			  		else {
			  			$db2->next_record();
			  			echo(date("d.m.Y - H:i", $db2->f("mkdate")));
			  			$db2->seek(0);
			  		}
			  		?>&nbsp;</td>
			  	<td class="blank">&nbsp;</td>
			  </tr>
		<?
		    if ($db2->num_rows()==0) {		      
		      ?>
		      	<tr>
				  	<td class="blank" valign="top" heigth=21 nowrap><img src='<?=$GLOBALS['ASSETS_URL'] ?>/images/forumleer.gif'><img src='<?=$GLOBALS['ASSETS_URL'] ?>/images/forumleer.gif'></td>
				  	<td class="blank" nowrap width="1%"align=left valign="top" nowrap>&nbsp;</td>
		
				  	<td class="printcontent" align="left" colspan="3" nowrap valign="bottom">Keine Dateien vorhanden.</td>
				  	<td class="blank">&nbsp;</td>
			  	</tr>
			  
			      <tr height="10">
			      	<td class="blank" colspan="6">&nbsp;</td>
			      </tr>
		      
			  <?php	
		    } else {
		      	?>
		      	<tr>
				  	<td class="blank" valign="top" heigth=21 nowrap><img src='<?=$GLOBALS['ASSETS_URL'] ?>/images/forumleer.gif'><img src='<?=$GLOBALS['ASSETS_URL'] ?>/images/forumleer.gif'></td>
				  	<td class="blank" nowrap width="1%"align=left valign="top" nowrap>&nbsp;</td>
					<td class="printcontent"></td>
				  	<td class="printcontent" align="left" colspan="2" nowrap valign="bottom">&nbsp;</td>
				  	<td class="blank">&nbsp;</td>
			  	</tr>
		      	<?php
		      while ($db2->next_record()) {
		      	//<?= getDownloadLink(urlencode("group/") . $db2->f("dokument_id"),$db2->f("filename"),20,'force') 
		      	?>
		      	<tr>
				  	<td class="blank" valign="top" heigth=21 nowrap><img src='<?=$GLOBALS['ASSETS_URL'] ?>/images/forumleer.gif'><img src='<?=$GLOBALS['ASSETS_URL'] ?>/images/forumleer.gif'></td>
				  	<td class="blank" nowrap width="1%"align=left valign="top" nowrap>&nbsp;</td>
				  	<td class="printhead"></td>
				  	
				  	
				  	<td class="printhead" align="left" nowrap valign="bottom" width="20%">&nbsp;&nbsp;<a href="<?= PluginEngine::getLink($this,array("file_id" => $db2->f("dokument_id"),"file_name" => $db2->f("filename")),"download")?>"><?php echo($db2->f("filename")); ?></a>&nbsp; (<?php 
				  		$downloadcount = $db2->f("downloads");
				  		echo(round($db2->f("filesize")/1024) . " kB / " . $downloadcount . " Download");
				  		if ($downloadcount > 1){
				  			echo("s");
				  		}
				  		echo (") ");
				  		// L�schsymbol, wenn L�schen erlaubt
		      			if(($perm->have_studip_perm("tutor", $GLOBALS["SessSemName"][1]))||($user->id==$db2->f("user_id"))) {
		      	  			echo "<a href=\"" . PluginEngine::getLink($this,array("file_id" => $db2->f("dokument_id")),"delete") . "\"><img src=\"".$GLOBALS['ASSETS_URL']."/images/trash.gif\" border=\"0\"/></a>";
		      			} else {
		      			  	   // nichts ausgeben		      	  		  	  
		      			} // Ende von if-else
				  	 ?></td>
				  	<td class="printhead" align="right" nowrap valign="bottom"><a href="about.php?username=<?php echo($db2->f("username")); ?>"><?php echo($db2->f("fullname")); ?></a>&nbsp;<?php echo(date("d.m.Y - H:i",$db2->f("mkdate"))); ?></td>
				  	<td class="blank">&nbsp;</td>
			  	</tr>
			  <?php
		      			      
		      } // Ende von while	
		      ?>
		      <tr height="10">
		      	<td class="blank" colspan="6">&nbsp;</td>
		      </tr>
		      <?php
		    } // Ende von if-else
		  } // Ende von while
		  ?>
		  	</table>
			</td>  
		  </tr>
		  <?php
		} // Ende von if-else
		
		
		?>
		  </table>
		  </td>
		  </tr>
		  <tr>
		  	<td class="blank">&nbsp;</td>
		  </tr>
		  
		
		<?  	
		
		  
		// Anzeige der Gruppen, in die hochgeladen werden darf
		
		$max_filesize=$GLOBALS["UPLOAD_TYPES"]["default"]["file_sizes"][$GLOBALS["SemUserStatus"]];
		
		$erlaubte = "";
		
		if (isset($GLOBALS["UPLOAD_TYPES"])){
			foreach ($GLOBALS["UPLOAD_TYPES"]["default"]["file_types"] as $ft) {
			  $erlaubte .= strtoupper($ft) . ", ";
			} // Ende von foreach
		}
		$erlaubte = substr($erlaubte,0,strlen($erlaubte)-2);		
		
		// Gruppenauswahl abh�ngig von Kursstatus
		if ($perm->have_studip_perm("tutor", $GLOBALS["SessSemName"][1])) {
		  // Nutzer ist Tutor -> darf in alle Gruppenbereiche hochladen
		  
		  $db->query("SELECT * FROM statusgruppen WHERE range_id='".$GLOBALS["SessSemName"][1]."' ORDER BY name ASC");
		  
		} elseif ($perm->have_studip_perm("autor", $GLOBALS["SessSemName"][1])) {
		  // Nutzer ist Autor, darf in eigene Gruppenbereiche hochladen
			
		  $db->query("SELECT * FROM statusgruppen,statusgruppe_user WHERE statusgruppen.statusgruppe_id=statusgruppe_user.statusgruppe_id AND user_id='". $user->id ."' AND range_id='".$GLOBALS["SessSemName"][1]."' ORDER BY name ASC");
			
		} // Ende von if-else
		
		
		// DB-Anfrage enth�lt erlaubte Gruppen
		if ($db->num_rows()==0) {
		  // Kein Ergebnis herausgekommen, keine Gruppe zuzuordnen
		  $gruppenwahl = "<option value=\"0\">Sie sind keiner Gruppe zugeordnet.</option>\n";
		} else {
		  // Es gibt Gruppen...
		  $gruppenwahl = "";
		  while ($db->next_record()) {
		    $gruppenwahl .= "<option value=\"" . $db->f("statusgruppe_id") . "\">" . $db->f("name") . "</option>\n";
		  } // Ende von while
		} // Ende von if-else
		
		
		// Ausgabe des Dateiupload-Bereichs
		
		?>
		
		  <tr><td class="blank" colspan="2">
		  
		  <center>
		    <table width="90%" style="{border-style: solid; border-color: #000000;  border-width: 1px;}" border="0" cellpadding="2" cellspacing="3">
		    
		    <tr>
		      <td class="steel1" width="20%"><font size=-1><b>Unzul&auml;ssige Dateitypen:</b></font></td>
		      <td class="steel1" width="80%"><font size=-1><?=$erlaubte?></font></td>
		    </tr>
		    <tr>
		      <td class="steel1" width="20%"><font size=-1><b>Maximale Gr&ouml;&szlig;e:</b></font></td>
		      <td class="steel1" width="80%"><font size=-1><b><? echo ($max_filesize / 1048576)?></b> Megabyte</font></td>
		    </tr>
		
		    <form enctype="multipart/form-data" NAME="upload_form" action="<?=PluginEngine::getLink($this,array(),"upload")?>" method="post">
		    <tr>
		      <td class="steelgraudunkel" colspan=2><font size=-1>1. Klicken Sie auf <b>'Durchsuchen...'</b>, um eine Datei auszuw&auml;hlen.</font></td>
		    </tr>
		    <tr>
		      <td class="steel1" colspan=2 align="left" valign="center"><font size=-1>&nbsp;Dateipfad:&nbsp;</font><br />
		      &nbsp;<INPUT NAME="the_file" TYPE="file" style="width: 70%" SIZE="30">&nbsp;</td></td>
		    </tr>
		    
		    <tr>
		      <td class="steelgraudunkel" colspan=2><font size=-1>2. W&auml;hlen Sie eine Gruppe, in deren Bereich diese Datei &uuml;bertragen werden soll.</font></td>
		    </tr>
		    <tr>
		      <td class="steel1" colspan=2 align="left" valign="center"><font size=-1>&nbsp;Gruppe:&nbsp;</font><br />
		      &nbsp;<select name="gruppe" size="1">
		      <?=$gruppenwahl?>
		      </select>
		      </td>
		    </tr>
		    
		    <tr>
		      <td class="steelgraudunkel" colspan="2"><font size=-1>3. Klicken Sie auf <b>'absenden'</b>, um die Datei hochzuladen.</font></td>
		    </tr>
		    <tr>
		      <td class="steel1" colspan="2" align="center" valign="center">
		        <input type="image" <?=makeButton("absenden", "src")?> value="Senden" align="absmiddle" onClick="return upload_start();" name="create" border="0">
		      </td>
		    </tr>
		    <!--<input type="hidden" name="cmd" value="upload">-->
		    <input type="hidden" name="upload_seminar_id" value="<?=$GLOBALS["SessSemName"][1]?>">
		
		    </form>	
		    </table>
		  </center>
		
		  </td></tr>
		
		  <tr><td class="blank">&nbsp;</td></tr>
		</table>	
		<?php
	} // end show function	
	
	function prepareUninstallation(){
		StudIPTemplateEngine::showInfoMessage(_("Die Tabelle group_docs muss manuell gel�scht werden."));
	}
} // end class

?>

	
